Bio::Map::Marker(3)

NAME
Bio::Map::Marker - An central map object representing a generic marker that can have multiple location in several maps.

SYNOPSIS
  # get map objects somehow

  # a marker with complex localisation
  $o_usat = Bio::Map::Marker->new(-name=>'Chad Super Marker 2',
                                  -positions => [ [$map1, $position1],
                                                  [$map1, $position2]
                                                ] );

  # The markers deal with Bio::Map::Position objects which can also
  # be explicitely created and passed on to markers as an array ref:
  $o_usat2 = Bio::Map::Marker->new(-name=>'Chad Super Marker 3',
                                  -positions => [ $pos1,
                                                  $pos2
                                                ] );

  # a marker with unique position in a map
  $marker1 = Bio::Map::Marker->new(-name=>'hypervariable1',
                                   -map => $map1,
                                   -position => 100
                                   );

  # an other way of creating a marker with unique position in a map:
  $marker2 = Bio::Map::Marker->new(-name=>'hypervariable2');
  $map1->add_element($marker2);
  $marker2->position(100);

  # position method is a short cut for get/setting unique positions
  # which overwrites previous values
  # to place a marker to other maps or to have multiple positions
  # for a map within the same map use add_position()

  $marker2->add_position(200);  # new position in the same map
  $marker2->add_position($map2,200); # new map

  # setting a map() in a marker or adding a marker into a map are
  # identical mathods. Both set the bidirectional connection which is
  # used by the marker to remember its latest, default map.

  # Regardes of how marker positions are created, they are stored and
  # returned as Bio::Map::PositionI objects:

  # unique position
  print $marker1->position->value, "\n";
  # several positions
  foreach $pos ($marker2->each_position($map1)) {
     print $pos->value, "\n";
  }

See Bio::Map::Position and Bio::Map::PositionI for more information.

DESCRIPTION
A Marker is a Bio::Map::Mappable with some properties particular to markers. It also offers a number of convienience methods to make dealing with map elements easier.

FEEDBACK

  Mailing Lists
User feedback is an integral part of the evolution of this and other Bioperl modules. Send your comments and suggestions preferably to the Bioperl mailing list. Your participation is much appreciated.

  bioperl-l@bioperl.org                  - General discussion
  http://bioperl.org/wiki/Mailing_lists  - About the mailing lists

  Reporting Bugs
Report bugs to the Bioperl bug tracking system to help us keep track of the bugs and their resolution. Bug reports can be submitted via the web:

  http://bugzilla.open-bio.org/

AUTHOR - Chad Matsalla
Email bioinformatics1@dieselwurks.com

CONTRIBUTORS
Heikki Lehvaslaiho heikki-at-bioperl-dot-org Lincoln Stein lstein@cshl.org Jason Stajich jason@bioperl.org Sendu Bala bix@sendu.me.uk

APPENDIX
The rest of the documentation details each of the object methods. Internal methods are usually preceded with a _

  new
 Title   : new
 Usage   : my $marker = Bio::Map::Marker->new( -name => 'Whizzy marker',
                                                  -position => $position);
 Function: Builds a new Bio::Map::Marker object
 Returns : Bio::Map::Marker
 Args    :
           -name    => name of this microsatellite
                       [optional], string,default 'Unknown'
           -default_map => the default map for this marker, a Bio::Map::MapI
           -position => map position for this marker, a Bio::Map::PositionI
           -positions => array ref of Bio::Map::PositionI objects

           position and positions can also take as values anything the
           corresponding methods can take

  default_map
 Title   : default_map
 Usage   : my $map = $marker->default_map();
 Function: Get/Set the default map for the marker.
 Returns : L<Bio::Map::MapI>
 Args    : [optional] new L<Bio::Map::MapI>

  map
 Title   : map
 Function: This is a synonym of the default_map() method

                   *** does not actually add this marker to the map! ***

 Status  : deprecated, will be removed in next version

  get_position_object
 Title   : get_position_class
 Usage   : my $position = $marker->get_position_object();
 Function: To get an object of the default Position class
           for this Marker. Subclasses should redefine this method.
           The Position returned needs to be a L<Bio::Map::PositionI> with
                   -element set to self.
 Returns : L<Bio::Map::PositionI>
 Args    : none for an 'empty' PositionI object, optionally
           Bio::Map::MapI and value string to set the Position's -map and -value
           attributes.

  position
 Title   : position
 Usage   : my $position = $mappable->position();
                   $mappable->position($position);
 Function: Get/Set the Position of this Marker (where it is on which map),
           purging all other positions before setting.
 Returns : L<Bio::Map::PositionI>
 Args    : Bio::Map::PositionI
            OR
           Bio::Map::MapI AND
           scalar
            OR
           scalar, but only if the marker has a default map

  add_position
 Title   : add_position
 Usage   : $marker->add_position($position);
 Function: Add a Position to this marker
 Returns : n/a
 Args    : Bio::Map::PositionI
            OR
           Bio::Map::MapI AND
           scalar
            OR
           scalar, but only if the marker has a default map

  positions
 Title   : positions
 Usage   : $marker->positions([$pos1, $pos2, $pos3]);
 Function: Add multiple Bio::Map::PositionI to this marker
 Returns : n/a
 Args    : array ref of $map/value tuples or array ref of Bio::Map::PositionI

  in_map
 Title   : in_map
 Usage   : if ( $marker->in_map($map) ) {}
 Function: Tests if this marker is found on a specific map
 Returns : boolean
 Args    : a map unique id OR Bio::Map::MapI